unit Pi_U;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, Math;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Edit1: TEdit;
    Label5: TLabel;
    Edit2: TEdit;
    Label6: TLabel;
    Edit3: TEdit;
    Label7: TLabel;
    Edit4: TEdit;
    Label8: TLabel;
    Edit5: TEdit;
    Label9: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Label10: TLabel;
    TabSheet2: TTabSheet;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Image2: TImage;
    Label15: TLabel;
    Label16: TLabel;
    Edit6: TEdit;
    Label17: TLabel;
    Edit7: TEdit;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Edit8: TEdit;
    Edit9: TEdit;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Label22: TLabel;
    TabSheet3: TTabSheet;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Image3: TImage;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Edit10: TEdit;
    Label31: TLabel;
    Edit11: TEdit;
    Label32: TLabel;
    Edit12: TEdit;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Edit13: TEdit;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    TabSheet4: TTabSheet;
    Label36: TLabel;
    Label37: TLabel;
    Label38: TLabel;
    Label39: TLabel;
    Label40: TLabel;
    Edit14: TEdit;
    Label41: TLabel;
    Edit15: TEdit;
    Label42: TLabel;
    Label43: TLabel;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    TabSheet5: TTabSheet;
    Label44: TLabel;
    Label45: TLabel;
    Label46: TLabel;
    Label47: TLabel;
    Label48: TLabel;
    Edit16: TEdit;
    Label49: TLabel;
    Label50: TLabel;
    Label51: TLabel;
    Button13: TButton;
    Button14: TButton;
    Button15: TButton;
    Label52: TLabel;
    Edit17: TEdit;
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button3Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Edit1.Clear;
  Edit2.Clear;
  Edit3.Clear;
  Edit4.Clear;
  Edit5.Clear;
  Edit2.Visible := False;
  Edit3.Visible := False;
  Edit4.Visible := False;
  Edit5.Visible := False;
  //Lschen der Zeichnung
  with Image1.Canvas do
  begin
    Pen.Color := clBlack;
    Brush.Color := clWhite;
    Rectangle(0,0,300,300);
    Ellipse(0,0,300,300);
  end;
  Edit1.SetFocus;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Randomize;
  Label10.Caption := FloatToStr(Pi);
  Label20.Caption := FloatToStr(Pi);
  Label34.Caption := FloatToStr(Pi);
  Label43.Caption := FloatToStr(Pi);
  Label51.Caption := FloatToStr(Pi);
  //Zeichnen eines weien Quadrates mit Kreis
  with Image1.Canvas do
  begin
    Pen.Color := clBlack;
    Brush.Color := clWhite;
    Rectangle(0,0,300,300);
    Ellipse(0,0,300,300)
  end; {with Image1.Canvas do}
end;

//Monte-Carlo-Methode

procedure TForm1.Button1Click(Sender: TObject);
var
  i, treffer, x, y, n: integer;
  Pi_wert: double;
begin
  n := StrToInt(Edit1.Text);          //Anzahl der Versuche einlesen
  if (n < 0) or (n > 50000) then      //unzulssige Eingabe abfangen
  begin
    ShowMessage('Unzulssige Versuchsanzahl!');
    Edit1.Clear;
    Exit;
  end  {if}
  else begin
    treffer := 0;                    // Zhler initialisieren
    Screen.Cursor := crHourGlass;
    for i := 1 to n do
    begin
      x := Random(300);             //Zufallskoordinaten ermitteln
      y := Random(300);
      Image1.Canvas.Pixels[x,y] := clRed;    //Punkte einzeichnen
      if Power(x,2) + Power(y,2) <= Power(300,2) then
        inc(treffer);               //Zhler inkrementieren
    end;  {for i := 1 to n do}
    Pi_wert := 4 * treffer / n;     //Nherungswert fr Pi berechnen
    //Ausgabe
    Edit2.Visible := True;
    Edit2.Text := IntToStr(n);
    Edit3.Visible := True;
    Edit3.Text := IntToStr(treffer);
    Edit4.Visible := True;
    Edit4.Text := IntToStr(n - treffer);
    Edit5.Visible := True;
    Edit5.Text :=  FloatToStrF(Pi_wert,ffFixed,11,14);
  end; {else}
  Screen.Cursor := crDefault;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  Edit6.Clear;
  Edit7.Visible := False;
  Edit7.Clear;
  Edit8.Visible := False;
  Edit8.Clear;
  Edit9.Visible := False;
  Edit9.Clear;
  Edit6.SetFocus;
end;

//Methode von Gregory

procedure TForm1.Button4Click(Sender: TObject);
var
  u, v, abbruch, Pi_u, Pi_v, MW_Pi, abweichg: extended;
  n: integer;
begin
  Screen.Cursor := crHourGlass;
  Edit6.SetFocus;
  abbruch := StrToFloat(Edit6.Text);
  //Startwerte
  n := 4;
  u := 4 * sqrt(2);
  v := 8;
  while ABS(v - u) > abbruch do
  begin
    //Iteration
    v := 2 * u * v / (u + v);    //Umfang des umbeschriebenen n-Ecks
    u := sqrt(u * v);            //Umfang des einbeschriebenen n-Ecks
    n := 2 * n;                  //Eckenanzahl verdoppeln
  end; {while ABS(v - u) > abbruch do}
  //Pi berechnen
  Pi_u := u / 2;
  Pi_v := v / 2;
  MW_Pi := (Pi_u + Pi_v) / 2;
  abweichg := ABS(Pi - MW_Pi);
  //Ausgabe
  Edit7.Visible := True;
  Edit7.Text := IntToStr(n);
  Edit8.Visible := True;
  Edit8.Text := FloatToStr(MW_Pi);
  Edit9.Visible := True;
  Edit9.Text := FloatToStr(abweichg);
  Screen.Cursor := crDefault;
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  Edit10.Clear;
  Edit11.Clear;
  Edit11.Visible := False;
  Edit12.Clear;
  Edit12.Visible := False;
  Edit13.Clear;
  Edit13.Visible := False;
  Edit10.SetFocus;
end;

//Methode von Cusanus

procedure TForm1.Button7Click(Sender: TObject);
var
  abbruch, inkr, umkr, Pi_inkr, Pi_umkr, MW_Pi: extended;
  n: integer;
begin
  Edit10.SetFocus;
  abbruch := StrToFloat(Edit10.Text);
  //Startwerte initialisieren
  n := 4;
  inkr := 1/4;
  umkr := sqrt(2)/4;
  Screen.Cursor := crHourGlass;
  while (umkr - inkr) > abbruch do
  begin
    //Iteration
    inkr := (umkr + inkr) / 2;       //Radius des Inkreises berechnen
    umkr := sqrt(umkr * inkr);       //Radius des Umkreises berechnen
    n := n * 2;                      //Eckenzahl verdoppeln
  end; {while (umkr - inkr) > abbruch do}
  //Pi berechnen
  Pi_inkr := 1 / inkr;
  Pi_umkr := 1 / umkr;
  MW_Pi := (Pi_inkr + Pi_umkr) / 2;
  //Ausgabe
  Edit11.Visible := True;
  Edit11.Text := IntToStr(n);
  Edit12.Visible := True;
  Edit12.Text := FloatToStr(MW_Pi);
  Edit13.Visible := True;
  Edit13.Text := FloatToStr(ABS(MW_Pi - Pi));
  Screen.Cursor := crDefault;
end;

procedure TForm1.Button12Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Button11Click(Sender: TObject);
begin
  Edit14.Clear;
  Edit15.Clear;
  Edit15.Visible := False;
  Edit14.SetFocus;
end;

//Methode von Gauss

procedure TForm1.Button10Click(Sender: TObject);
var
  a, b, s, hilf, t, Pi_wert: extended;
  i, n: integer;
begin
  Edit14.SetFocus;
  n := StrToInt(Edit14.Text);
  if (n < 1) or (n > 3) then
  begin
    //Unzulssige Versuchsanzahl abfangen
    ShowMessage('Unzulssige Versuchsanzahl!');
    Exit;
  end {if}
  else begin
    //Startwerte initialisieren
    a := 1;
    b := 1 / sqrt(2);
    s := 1 / 2;
    for i := 1 to n do
    begin
      //Iteration
      hilf := a;
      a := (a + b) * 0.5;
      b := sqrt(hilf * b);
      t := Power((a - hilf),2);
      if t = 0 then exit;
      t := t * Power(2,i);
      s := s - t;
    end; {for i := 1 to n do}
    Pi_wert := Power((a + b),2) / (2 * s);
    //Ausgabe
    Edit15.Visible := True;
    Edit15.Text := FloatToStr(Pi_wert);
  end; {else}
end;

procedure TForm1.Button15Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Button14Click(Sender: TObject);
begin
  Edit16.Clear;
  Edit16.Visible := False;
  Edit17.Clear;
  Edit17.SetFocus;
end;

//Arcustangens-Methode nach Machin

procedure TForm1.Button13Click(Sender: TObject);
const
  x1 = 1/5;         //Argumente des arctan
  x2 = 1/239;
var
  nenner1, nenner2 : Longint;
  a1, a2 : extended;      //Werte der arctan
  zaehler1, zaehler2, Pi_wert : extended;
  anz, i : integer;
begin
  //Anzahl der Iterationen
  anz := StrToInt(Edit17.Text);
  if (anz < 0) or (anz > 12) then
  begin
    ShowMessage('Unzulssige Versuchsanzahl!');
    Exit;
  end
  else begin
    //Startwerte initialisieren
    nenner1 := 1;
    nenner2 := 1;
    a1 := 0;
    a2 := 0;
    zaehler1 := x1;
    zaehler2 := x2;

    for i := 1 to anz do begin
      //Iteration
      a1 := a1 + zaehler1/nenner1;
      zaehler1 := -zaehler1*x1*x1;
      Inc(nenner1, 2);

      a2 := a2 + zaehler2/nenner2;
      zaehler2 := -zaehler2*x2*x2;
      Inc(nenner2, 2);
    end;  {for i := 1 to anz do begin}
    Pi_wert := 4*(a1*4-a2);
    //Ausgabe
    Edit16.Visible := True;
    Edit16.Text := FloatToStr(Pi_wert);
  end; {else}
end;

end.